/*
$Id: mail.c,v 1.17 2004/12/16 08:15:34 alex Exp $
	mail.c--- send mail
	(C) Copyright 1994 by Alex
*/

#ifndef lint
static char * rcsid __attribute__((unused)) = "$Id: mail.c,v 1.17 2004/12/16 08:15:34 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<strings.h>
#include	"edb/edb.h"

#define	SENDMAIL_PATH		"/usr/sbin/sendmail"


/*#mail_send_notify--- send a mail */
int
mail_send_notify(char *recipient, char *subject, char *reply_to, FILE *text)
{
	FILE *fp;
	char *command = NULL;
	char	tempfile[BUFSIZ];
	int	fd;

	strcpy(tempfile, "/tmp/edb-mail.XXXXXXXX");
	fd = mkstemp(tempfile);
	if(fd<0) return FALSE;
	fp = fdopen(fd, "w");
	if(fp == NULL) return FALSE;

	fprintf(fp, "From %s\n", EDB_ADMIN_MAILADDR);
	fprintf(fp, "Return-Path: <%s>\n", STRisVALID(reply_to) ? reply_to : EDB_ADMIN_MAILADDR);
	fprintf(fp, "Reply-To: <%s>\n", STRisVALID(reply_to) ? reply_to : EDB_ADMIN_MAILADDR);
	fprintf(fp, "Errors-To: %s\n", STRisVALID(reply_to) ? reply_to : EDB_ADMIN_MAILADDR);
	fprintf(fp, "From: %s\n", EDB_ADMIN_MAILADDR);
	fprintf(fp, "To: %s\n", recipient);
	fprintf(fp, "Subject: %s\n", subject);
	fprintf(fp, "Content-Type: text/plain; charset=\"iso-2022-jp\"\n");
	fprintf(fp, "Content-Transfer-Encoding: 7bit\n");
	fprintf(fp, "\n");

	fprintf(fp, "--------- [ " NAME_OF_DB " Automatic Notification System ] ---------\n\n");
	rewind(text);
	file_utf8_to_jis(text, fp);
	fprintf(fp, "\n--- " NAME_OF_DB " Administrator <%s>\n\n", EDB_ADMIN_MAILADDR);
	fclose(fp);

	asprintf(&command,
		"/bin/cat %s | %s -f%s '%s' 1> /dev/null 2>&1 ; /bin/rm -f %s &",
		tempfile, SENDMAIL_PATH, STRisVALID(reply_to) ? reply_to : EDB_ADMIN_MAILADDR, recipient, tempfile);
	system(command);
	FREE(command);
	return TRUE;
}

