/*
$Id: system.c,v 1.7 2009/07/31 11:26:47 alex Exp $
	system.c--- 
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: system.c,v 1.7 2009/07/31 11:26:47 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	"edb/edb.h"

/*#system_loadaverage--- system load average */
double
system_loadaverage()
{
	double	loadavg[3];

	getloadavg(loadavg, sizeof(loadavg)/sizeof(loadavg[0]));
	return loadavg[0];
}

double
edb_loadaverage(EdbContext ec)
{
	double	la;

	la = system_loadaverage();
	if(edb_pgsql_is_connected(ec)) {
		utf8_t	*s;
		double	v;

		s = edb_pgsql_query_one_text(ec, (utf8_t *)"SELECT getloadaverage()");
		if(STRisVALID(s)) {
			v = ATOF((char *)s);
			la = max(v, la);
		}
		FREE(s);
	}
	return la;
}

